import Feature from "./Feature";
import { ListFeatureOptions } from "../types/Feature";
import { WarrantRequestOptions } from "../types/WarrantRequestOptions";
import { CreatePricingTierParams, ListPricingTierOptions } from "../types/PricingTier";
import Warrant, { PolicyContext, WarrantObject } from "../types/Warrant";
export default class PricingTier implements WarrantObject {
    pricingTierId: string;
    constructor(pricingTierId: string);
    static create(pricingTier: CreatePricingTierParams, options?: WarrantRequestOptions): Promise<PricingTier>;
    static get(pricingTierId: string, options?: WarrantRequestOptions): Promise<PricingTier>;
    static delete(pricingTierId: string, options?: WarrantRequestOptions): Promise<void>;
    static listPricingTiers(listOptions?: ListPricingTierOptions, options?: WarrantRequestOptions): Promise<PricingTier[]>;
    static listPricingTiersForTenant(tenantId: string, listOptions?: ListPricingTierOptions, options?: WarrantRequestOptions): Promise<PricingTier[]>;
    static assignPricingTierToTenant(tenantId: string, pricingTierId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removePricingTierFromTenant(tenantId: string, pricingTierId: string, options?: WarrantRequestOptions): Promise<void>;
    static listPricingTiersForUser(userId: string, listOptions?: ListPricingTierOptions, options?: WarrantRequestOptions): Promise<PricingTier[]>;
    static assignPricingTierToUser(userId: string, pricingTierId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removePricingTierFromUser(userId: string, pricingTierId: string, options?: WarrantRequestOptions): Promise<void>;
    listFeatures(listOptions?: ListFeatureOptions, options?: WarrantRequestOptions): Promise<Feature[]>;
    assignFeature(featureId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    removeFeature(featureId: string, options?: WarrantRequestOptions): Promise<void>;
    hasFeature(featureId: string, context?: PolicyContext, options?: WarrantRequestOptions): Promise<boolean>;
    getObjectType(): string;
    getObjectId(): string;
}
